package com.exit.mixpanel;

import io.flutter.plugin.common.JSONUtil;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;


import com.google.android.gms.common.util.JsonUtils;
import com.mixpanel.android.mpmetrics.MixpanelAPI;
import com.mixpanel.android.util.JSONUtils;

import android.util.Log;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.Map;

import static java.security.AccessController.getContext;

public class MixpanelPlugin implements MethodCallHandler {
    MixpanelAPI mixpanel;

    public static void registerWith(Registrar registrar) {
        final MethodChannel channel = new MethodChannel(registrar.messenger(), "mixpanel");
        channel.setMethodCallHandler(new MixpanelPlugin());
    }

    @Override
    public void onMethodCall(MethodCall call, Result result) {
        if (call.method.equals("init")) {
            String token = call.argument("token");
            mixpanel = MixpanelAPI.getInstance(getContext(), token);
        } else if (call.method.equals("track")) {
            Map props = (Map) call.arguments;
            String eventName = (String) props.get("event");
            String properties = "";
            if(props.containsKey("properties"))
                properties = ((Map) props.get("properties")).toString();
            try {
                JSONObject pros = new JSONObject(properties);
                mixpanel.track(eventName, pros);
            }catch (JSONException ex){
                mixpanel.track(eventName);
            }
        } else {
            result.notImplemented();
        }
    }
}
