import 'package:flutter/services.dart';

class NatMixpanel {
  final String token;

  static final NatMixpanel _mixpanel = new NatMixpanel._internal();

  factory NatMixpanel() => _mixpanel;

  NatMixpanel._internal();

  void init(String token){
    _channel.invokeMethod("init", {"token": token});
  }

  static const MethodChannel _channel = const MethodChannel('mixpanel');

  void track(String event_name, {Map properties, Function callback}) {
    if (properties != null)
      _channel.invokeMethod(
          "track", {"event": event_name, "properties": properties});
    else
      _channel.invokeMethod("track", {"event": event_name});
  }

  void track_links(String css_selector, String event_name, {var properties}) {}

  void track_forms(String css_selector, String event_name, {var properties}) {}

  void track_pageview({String page}) {}

  void register(Map properties) {}

  void register_once(Map properties, {var default_value}) {}

  void unregister(String property_name) {}

  get_property(String property_name) {}

  void identify(String unique_id) {}

  void alias(String alias) {}

  get_distinct_id() {}

  void name_tag(String name) {}

  void set_config(Map config) {}

  void disable({List events}) {}
}
